"use strict";
alert("Confirm program start!");
document.writeln("STARTED!" +  "<br>");


const stat = 1E5;
const eps = 1E-14;
const cfs = [1.0, -1.0 / 3.0, 1.0 / 7.0, -1.0 / 11.0];
const d = 1E-4;
const x = [1.0,1.0+d,1.0+d+d,1.0+d+d+d];
const y = []
for (let i=0; i<4; i++) y[i] = fn(x[i]);

function fn(x)
	{
	return cfs[0] + cfs[1] * Math.cos(x) + cfs[2] * Math.cos(2.0 * x) + cfs[3] * Math.cos(3.0 * x);
	}

function MatVec(M,V)
    {
    let L = V.length;
    let vOut = [L];
    for (let i=0; i<L; i++) vOut[i] = 0.0;

    for (let i=0; i<L; i++)
        {
        for (let j=0; j<L; j++) vOut[i] = vOut[i] + M[i][j]*V[j];            
        }
    
        return vOut;
    }


let M = [4];
for (let i=0; i<4; i++ )
    {
    M[i] = [4]
    }

for (let i=0; i<4; i++)
    {
    M[i][0] = 1.0;
    M[i][1] = Math.cos( x[i] );
    M[i][2] = Math.cos( 2.0*x[i] );
    M[i][3] = Math.cos( 3.0*x[i] );
    }

let iM = matrix_invert(M);
let cfs_single = MatVec(iM,y)

let kahanSum = [4];
let kahanC = [4];
for (let i=0; i<4; i++)
    {
    kahanSum[i]=0.0;
    kahanC[i]=0.0;
    }

for (let i=0; i<stat; i++)
	{
	let pertM = [4];
    for (let k=0; k<4; k++) pertM[k] = [4];

	for (let k=0; k<4; k++)
		{
		for (let l=0; l<4; l++) pertM[k][l] = M[k][l]+eps*( 2.0*Math.random() -1.0) ;
		}

	let iPertM = matrix_invert(pertM);
	let cPert = MatVec(iPertM,y);

    let kahanY = [4];
    let kahanT = [4];
	for (let j=0; j<4; j++)
        {
        kahanY[j] = cPert[j] - kahanC[j];
        kahanT[j] = kahanSum[j] + kahanY[j];
        kahanC[j] = (kahanT[j] - kahanSum[j] ) - kahanY[j];
        kahanSum[j] = kahanT[j];
        }
	}

let sp = "______";

document.writeln("Truth<br>");
for (let i=0; i<4; i++) document.writeln(cfs[i] + sp );
document.writeln("<br>");

document.writeln("<br>");
document.writeln("AVERAGED<br>");
for (let i=0; i<4; i++) document.writeln(kahanSum[i]/stat + sp);
document.writeln("<br>");
for (let i=0; i<4; i++) document.writeln(Math.abs(kahanSum[i]/stat - cfs[i]) + sp);
document.writeln("<br>");

document.writeln("<br>");
document.writeln("SINGLE<br>");
for (let i=0; i<4; i++) document.writeln(cfs_single[i] + sp);
document.writeln("<br>");
for (let i=0; i<4; i++) document.writeln( Math.abs(cfs_single[i] - cfs[i]) + sp);
document.writeln("<br>");

document.writeln("<br>");
document.writeln("RATIOS<br>");
for (let i=0; i<4; i++) document.writeln( Math.abs(cfs_single[i] - cfs[i])/Math.abs(kahanSum[i]/stat - cfs[i]) + sp);
/************************************************************/ 

function matrix_invert(M){
   
    if(M.length !== M[0].length){return;}
    
    var i=0, ii=0, j=0, dim=M.length, e=0, t=0;
    var I = [], C = [];
    for(i=0; i<dim; i+=1){

        I[I.length]=[];
        C[C.length]=[];
        for(j=0; j<dim; j+=1){
            
            if(i==j){ I[i][j] = 1; }
            else{ I[i][j] = 0; }
            
            C[i][j] = M[i][j];
        }
    }
    
    for(i=0; i<dim; i+=1){
        e = C[i][i];
        
        if(e==0){
            for(ii=i+1; ii<dim; ii+=1){
                if(C[ii][i] != 0){
                    for(j=0; j<dim; j++){
                        e = C[i][j];
                        C[i][j] = C[ii][j];
                        C[ii][j] = e;
                        e = I[i][j];
                        I[i][j] = I[ii][j];
                        I[ii][j] = e;
                    }

                    break;
                }
            }
            e = C[i][i];
            if(e==0){return}
        }
        
        for(j=0; j<dim; j++){
            C[i][j] = C[i][j]/e;
            I[i][j] = I[i][j]/e;
        }
        
        for(ii=0; ii<dim; ii++){
            if(ii==i){continue;}
            
            e = C[ii][i];
            
            for(j=0; j<dim; j++){
                C[ii][j] -= e*C[i][j];
                I[ii][j] -= e*I[i][j];
            }
        }
    }
    
    return I;
}