"use strict";

const stat = 1e6;
const eps = 1E-7;
const x0 = 1.0/3.0;
const n = 15;
let truth = 0.0000000696917193762563239137308507191523368295578192819843351;
const width = 5E-3;
const nHistoBins = 50;

alert("Confirm program start!");
document.writeln("STARTED!" +  "<br>");


function a(n,x)
	{
    if (n==1) return x;
	else if (n==2) return x*x;
	else return (2.0*x)*a(n-2,x)+(x-2.0)*a(n-1,x);
	}

function binNb(xMin,xMax,nBins,x)
    {
    let dx = (xMax-xMin)/nBins;
    let delta = x-xMin;
    return Math.floor(delta/dx);
    }

function createHisto(xMin, xMax, nBins)
    {
    let histo = [2];
    histo[0] = [nBins];
    histo[1] = [nBins];

    let dx = (xMax-xMin)/nBins;
    histo[0][0] = xMin + dx/2.0;

    for (let i=0; i<nBins; i++)
        {
        histo[0][i] = histo[0][0] + i*dx;
        histo[1][i] = 0.0;
        }
    return histo;
    }


function fillHisto(histo, x)
    {
    let L = histo[0].length;
    let dx = (histo[0][L-1]-histo[0][0])/(L-1.0);
    let xMin = histo[0][0]-dx/2.0;
    let xMax = histo[0][L-1]+dx/2.0;
    let bin = binNb(xMin,xMax,L,x);
    if (0<=bin && bin<L) histo[1][bin]++;
    }

function normHisto(histo)
    {
    let L = histo[0].length;
    let sum = 0.0;
    for (let i=0; i<L; i++) sum = sum + histo[1][i];
    for (let i=0; i<L; i++) histo[1][i] = histo[1][i]/sum;
    }


let kahanSum = 0;
let kahanC = 0;

let xMin = truth-width;
let xMax = truth+width;
let histo = createHisto(xMin,xMax,nHistoBins);

for (let i=0; i<stat; i++)
    {
    let x = x0 + eps*( 2.0*Math.random() - 1.0);
    let y = a(n,x)

    let kahanY = y - kahanC;
    let kahanT = kahanSum + kahanY;
    kahanC = (kahanT - kahanSum) - kahanY;
    kahanSum = kahanT

    fillHisto(histo,y);
    }

let single = a(n,x0);
let d_st = Math.abs(single-truth);

let avg = kahanSum/stat;
let d_at = Math.abs(avg-truth);

let d_rat = d_st/d_at;
document.writeln("Truth = " + truth + "<br>");
document.writeln("AV = " + avg + ", delta = " +  d_at + "<br>");
document.writeln("Single = " + single+ ", delta = " + d_st + "<br>");
document.writeln("Sing/AV delta  = " + d_rat + "<br>");


normHisto(histo);
document.writeln("<br>");
for (let i=0; i<nHistoBins; i++)
		{
		let xVal = histo[0][i];
		let yVal = histo[1][i];
		document.writeln( "(" + xVal.toFixed(5) + "," + yVal.toFixed(5) + ") " );
		}