import math
import random
import numpy as np

eps = 1E-7
x0 = 1.0/3.0
n = 15
stat = int(1E6)
nHistoBins = 50
width = 5E-13
truth = 0.0000000696917193762563239137308507191523368295578192819843351;

def a(m, x):
    if m == 1:
        return x
    elif m==2:
        return x*x
    else:
        return (2.0*x)*a(m-2,x)+(x-2.0)*a(m-1,x)


def binNb(xMin, xMax, nBins, x):
    dx = (xMax-xMin)/nBins
    delta = x-xMin
    return int(math.floor(delta/dx))

def createHisto(xMin, xMax, nBins):
    histo = np.zeros([2,nBins])
    dx = (xMax-xMin)/nBins
    histo[0][0] = xMin + dx/2.0
    for i in range(0, nBins):
        histo[0][i] = histo[0][0] + i*dx
        histo[1][i] = 0.0
    return histo

def fillHisto(histo, x):
    L = histo[0].size
    dx = (histo[0][L-1]-histo[0][0])/(L-1.0)
    xMin = histo[0][0]-dx/2.0
    xMax = histo[0][L-1]+dx/2.0
    bin = binNb(xMin,xMax,L,x)
    if (0<=bin & bin<L):
        histo[1][bin]=histo[1][bin]+1

def normHisto(histo):
    L = histo[0].size
    sum = 0.0
    for i in range(0,L):
        sum = sum + histo[1][i]
    for i in range(0,L):
        histo[1][i] = histo[1][i]/sum

kahanSum = 0.0
kahanC = 0.0
xMin = truth-width
xMax = truth+width
histo = createHisto(xMin,xMax,nHistoBins)

for i in range(1, stat+1):
    x = x0 + eps*( 2.0*random.random() - 1.0)
    y = a(n,x)

    kahanY = y - kahanC
    kahanT = kahanSum + kahanY
    kahanC = (kahanT-kahanSum) - kahanY
    kahanSum = kahanT

    fillHisto(histo,y)

single = a(n, x0)
d_st = abs(single-truth)
avg = kahanSum/stat
d_av = abs(avg - truth)
d_rat = d_st / d_av

print("Truth = " + str(truth))
print("AV = " + str(avg) + ", delta = " + str(d_av))
print("Single = " + str(single) + ", delta = " + str(d_st))
print("Sing/AV delta  = " + str(d_rat))

normHisto(histo)
print()
for i in range (0, nHistoBins):
    xVal = str(histo[0][i])
    yVal = str(histo[1][i])
    print( "(" + xVal + "," + yVal + ") " , end="")
